DirectCanvas = new Canvas(300, 300);

AppMobiImage = function(source) {
	var _s = '';
	var _h = 0;
	var _w = 0;
	//var _id = DirectCanvas.createImage(_s, _w, _h);
	var _id;
	if(typeof source!="undefined") { 
		_id = DirectCanvas.createImage(source);  // use w, h if they will be used in createImage
		_s = source;
		_c = true;
	} //:TODO make it work if source was not given
	var retval = {
		id:_id,
		set src (s) {
			_s = s;
			DirectCanvas.setImageSource(this.id, s);
			if(this.onload) {
				console.log('AppMobiImage onload()');
				this.onload();
			}
		},
		get src () {
			return _s;
		},
		set height (h) {
			_h = h;
			DirectCanvas.setImageHeight(this.id, h);
		},
		get height () {
			return _h;
		},
		set width (w) {
			_w = w;
			DirectCanvas.setImageWidth(this.id, w);
		},
		get width () {
			return _w;
		}
	}
	return retval;
};

Image = AppMobiImage;

AppMobi = function() {
	
	return {
		
		canvas: {
			context: function() {
			},
			getContext: function() {return new this.context();}, 
		},
		isnative: true//internal only
	}
}();
var fontID =0; // used to distinguish the font
DContext = AppMobi.canvas.context;
DContext.prototype = {
	get fillStyle() {
		return "Not Implemented!";
	}, 
	set fillStyle(val) {
		DirectCanvas.setFillStyle(val);
	},
	get clearStyle() {
		return "Not Implemented!";
	}, 
	set clearStyle(val) {
		DirectCanvas.setClearStyle(val);
	},
	get strokeStyle() {
		return "Not Implemented!";
	}, 
	set strokeStyle(val) {
		DirectCanvas.setStrokeStyle(val);
	},
	get globalAlpha() {
		return DirectCanvas.getGlobalAlpha();
	}, 
	set globalAlpha(val) {
		DirectCanvas.setGlobalAlpha(val);
	},
	get font() {
		return "Not Implemented!";
	}, 
	set font(val) {
		//TODO: Add check to remove existing font image if already exists
		fontID = DirectCanvas.createFont(val);
	},
}
DContext.prototype.present = function() {
	DirectCanvas.present();
}
DContext.prototype.save = function() {
	DirectCanvas.save();
}
DContext.prototype.restore = function() {
	DirectCanvas.restore();
}
DContext.prototype.scale = function(x, y) {
	DirectCanvas.scale(x, y);
}
DContext.prototype.rotate = function(a) {
	DirectCanvas.rotate(a);
}
DContext.prototype.translate = function(x, y) {
	DirectCanvas.translate(x, y);
}
DContext.prototype.clear = function() {
	DirectCanvas.clear();
}
DContext.prototype.fillRect = function(x, y, w, h) {
	DirectCanvas.fillRect(x, y, w, h);
}
DContext.prototype.strokeRect = function(x, y, w, h) {
	DirectCanvas.strokeRect(x, y, w, h);
}
DContext.prototype.clearRect = function(x, y, w, h) {
	DirectCanvas.clearRect(x, y, w, h);
}
DContext.prototype.drawImageTile = function(image, x, y, t, w, h, flipx, flipy, a) {
	if(typeof a != 'undefined') {
		DirectCanvas.drawImageTile(image.id, x, y, t, w, h, flipx, flipy, a);
	} else if(typeof h != 'undefined') {
		DirectCanvas.drawImageTile(image.id, x, y, t, w, h, flipx, flipy);
	} else {
		DirectCanvas.drawImageTile(image.id, x, y, t); // t is alpha here
	}
}
DContext.prototype.drawRotatedImage = function(image, x, y, w, h, x2, y2, w2, h2, tx, ty, angle) {
		DirectCanvas.drawRotatedImage(image.id, x, y, w, h, x2, y2, w2, h2, tx, ty, angle);
}
DContext.prototype.drawImage = function(image, x, y, w, h, x2, y2, w2, h2) {
	if(typeof x2 != 'undefined') {
		DirectCanvas.drawImage(image.id, x, y, w, h, x2, y2, w2, h2);
	} else if(typeof w != 'undefined') {
		DirectCanvas.drawImage(image.id, x, y, w, h);
	} else {
		DirectCanvas.drawImage(image.id, x, y);
	}
}

DContext.prototype.drawFont = function(text, x, y, align) {
		DirectCanvas.drawFont(fontID, text, x, y, align);
}

DContext.prototype.measureText = function(text) {
	//:Note - Temp implementation, return value is not correct
	var metrics = {width:text.length*8};
	return (metrics);
}

DContext.prototype.createPattern= function() {
	//:Stub, not implemented
	return null;
}

AppMobiContext = function(){
}
AppMobiContext.prototype.include = function(file) {
	DirectCanvas.include(file);
}
AppMobi.context = new AppMobiContext();

//DirectCanvas.log('DirectCanvas.log test');
console = function() {
	return {
		log: function(val) {
			DirectCanvas.log(val);
		}
	}
}();
//console.log('console.log test');


//-----------------------------------------------------------------------------------
// The following is from timers.js, note that tick() needs to be called 

// Mock Timers - Copyright TJ Holowaychuk <tj@vision-media.ca> (MIT Licensed)

;(function(){

  /**
   * Localized timer stack.
   */
  
  var timers = []
  
  /**
   * Set mock timeout with _callback_ and timeout of _ms_.
   *
   * @param  {function} callback
   * @param  {int} ms
   * @return {int}
   * @api public
   */
  
  setTimeout = function(callback, ms) {
    var id
  	return id = setInterval(function(){
  	  callback()
  	  clearInterval(id)
  	}, ms)
  }
  
  /**
   * Set mock interval with _callback_ and interval of _ms_.
   *
   * @param  {function} callback
   * @param  {int} ms
   * @return {int}
   * @api public
   */

  setInterval = function(callback, ms) {
    callback.step = ms, callback.current = callback.last = 0
    return timers[timers.length] = callback, timers.length
  }
  
  /**
   * Destroy timer with _id_.
   *
   * @param  {int} id
   * @return {bool}
   * @api public
   */

  clearInterval = function(id) {
    return delete timers[--id]
  }
  
  /**
   * Reset timers.
   *
   * @return {array}
   * @api public
   */
  
  resetTimers = function() {
    return timers = []
  }
  
  /**
   * Increment each timers internal clock by _ms_.
   *
   * @param  {int} ms
   * @api public
   */
  tick = function(ms) {
    for (var i = 0, len = timers.length; i < len; ++i)
      if (timers[i] && (timers[i].current += ms))
        if (timers[i].current - timers[i].last >= timers[i].step) {
          var times = Math.floor((timers[i].current - timers[i].last) / timers[i].step)
          var remainder = (timers[i].current - timers[i].last) % timers[i].step
          timers[i].last = timers[i].current - remainder
          while (times-- && timers[i]) timers[i]()
        }
  }
  
})()
